//Create a class for contact sensor
package ContactSensor
import Timer.SimulatedTimer

public class ContactSensors {
	private int deviceNumbers
	private List contacts
	def sendEvent

	//For one device(We cannot have obj.id)-> We should have obj[0].id
	private String id = "contactSensorID0"
	private String label = "contactSensor0"
	private String displayName = "contactSensor0"
	private String contactState = "closed"
	private String latestValue = "closed"

		
	ContactSensors(Closure sendEvent, int deviceNumbers) {
		this.sendEvent = sendEvent		
		this.deviceNumbers = deviceNumbers
		this.contacts = []

		contacts.add(new ContactSensor(id, label, displayName, this.contactState, this.latestValue))
	}

	//Methods for closures
	def count(Closure Input) {
		contacts.count(Input)
	}
	def size() {
		contacts.size()
	}
	def each(Closure Input) {
		contacts.each(Input)
	}
	def find(Closure Input) {
		contacts.find(Input)
	}
	def collect(Closure Input) {
		contacts.collect(Input)
	}

	//By Model Checker
	def setValue(LinkedHashMap eventDataMap) {
		contacts[0].setValue(eventDataMap["value"])
		this.latestValue = contacts[0].latestValue
		this.contactState = contacts[0].contactState
		sendEvent(eventDataMap)
	}

	def currentValue(String deviceFeature) {
		contacts[0].currentValue(deviceFeature)//It is called if we have only one device
	}

	def latestValue(String deviceFeature) {
		contacts[0].latestValue(deviceFeature)//It is called if we have only one device
	}

	def getAt(int ix) {
		contacts[ix]
	}
}
