////////////////////////////////////////
//import libraries
import groovy.transform.Field


//import classes
//Importing Classes
import ContactSensor.ContactSensor
import ContactSensor.ContactSensors
import DoorControl.DoorControl
import DoorControl.DoorControls
import Lock.Lock
import Lock.Locks
import Thermostat.Thermostat
import Thermostat.Thermostats
import Switch.Switch
import Switch.Switches
import PresenceSensor.PresenceSensor
import PresenceSensor.PresenceSensors
import Logger.Logger
import Location.LocationVar
import Location.Phrase
import appTouch.Touched
import NfcTouch.NfcTouch
import AeonKeyFob.AeonKeyFob
import AeonKeyFob.AeonKeyFobs
import MusicPlayer.MusicPlayer
import MusicPlayer.MusicPlayers
import Timer.SimulatedTimer

//GlobalVariables
@Field def location = new LocationVar()
//Settings variable defined to settings on purpose
@Field def settings = [app: "app"]
//Global variable for state[mode]
@Field def state = [home:[],away:[],night:[]]
//Create a global logger object for methods
@Field def log = new Logger()


//Global variables for files
@Field File extractedObjectsApp1 = new File("Extractor/App1/extractedObjectsApp1.groovy")
@Field File extractedObjectsApp2 = new File("Extractor/App2/extractedObjectsApp2.groovy")
@Field File extractedObjectsConstructorApp1 = new File("Extractor/App1/extractedObjectsConstructorApp1.groovy")
@Field File extractedObjectsConstructorApp2 = new File("Extractor/App2/extractedObjectsConstructorApp2.groovy")


//Empty the files
if (App == "App1") {
	extractedObjectsApp1.write("")
	extractedObjectsConstructorApp1.write("")
} else if (App == "App2") {
	extractedObjectsApp2.write("")
	extractedObjectsConstructorApp2.write("")
}





//Global objects
//Global Object for class Touch Sensor!
@Field touchSensorObjects = 0
@Field def touchSensorObject0
@Field def touchSensorObject1
@Field def touchSensorObject2
//Global Object for class switch!
@Field switchObjects = 0
@Field def switchObject0
@Field def switchObject1
@Field def switchObject2
//Global Object for class lock!
@Field lockObjects = 0
@Field def lockObject0
@Field def lockObject1
@Field def lockObject2
//Global Object for class door control!
@Field doorControlObjects = 0
@Field def doorControlObject0
@Field def doorControlObject1
@Field def doorControlObject2
//Global Object for class contact sensor!
@Field contactObjects = 0
@Field def contactObject0
@Field def contactObject1
@Field def contactObject2
//Global Object for class presence sensor!
@Field presenceSensorObjects = 0
@Field def presenceSensorObject0
@Field def presenceSensorObject1
@Field def presenceSensorObject2
//Global Object for class thermostat!
@Field thermostatObjects = 0
@Field def thermostatObject0
@Field def thermostatObject1
@Field def thermostatObject2
//Global Object for class music player!
@Field musicPlayerObjects = 0
@Field def musicPlayerObject0
@Field def musicPlayerObject1
@Field def musicPlayerObject2
//Global Object for class music player!
@Field aeonKeyFobObjects = 0
@Field def aeonKeyFobObject0
@Field def aeonKeyFobObject1
@Field def aeonKeyFobObject2


//Global variables
//For mode
@Field modeVariables = 0
@Field mode0
@Field mode1
@Field mode2
@Field mode3
@Field mode4
@Field mode5
//For number
@Field numberVariables = 0
@Field number0
@Field number1
@Field number2
@Field number3
@Field number4
@Field number5
//For time
@Field timeVariables = 0
@Field time0
@Field time1
@Field time2
@Field time3
@Field time4
@Field time5
//For enum
@Field enumVariables = 0
@Field enum0
@Field enum1
@Field enum2
@Field enum3
@Field enum4
@Field enum5
//For phone
@Field phoneVariables = 0
@Field phone0
@Field phone1
@Field phone2
@Field phone3
@Field phone4
@Field phone5
//For contact
@Field contactVariables = 0
@Field contact0
@Field contact1
@Field contact2
@Field contact3
@Field contact4
@Field contact5



/////Input Methods/////
//input "",""
def input(String name, String type) {
	LinkedHashMap metaData = []
	metaData.put('name',name)
	metaData.put('type',type)
	input(metaData)
}

//input "","",linkedHashMap
def input(LinkedHashMap metaData, String name, String type) {
	metaData.put('name',name)
	metaData.put('type',type)
	input(metaData)
}

//input linkedHashMap
def input(LinkedHashMap metaData) {
	if (metaData.containsKey('title')) {
		println metaData['title']
	}
	if (metaData.containsKey('options')) {
		println "Options: "+metaData['options']
	}
	switch(metaData['type']) {
		case "capability.lock":
			if (lockObjects == 0) {
				lockObject0 = metaData['name']
				this[lockObject0] = new Locks({}, 1)
			} else if (lockObjects == 1) {
				lockObject1 = metaData['name']
				this[lockObject1] = new Locks({}, 1)
			} else if (lockObjects == 2) {
				lockObject2 = metaData['name']
				this[lockObject2] = new Locks({}, 1)
			}

			lockObjects=lockObjects+1

			settings.put(metaData['name'], metaData['name']) 

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class lock!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.lockObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class lock!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.lockObject\n")
			}
			break
		case "capability.alarm":
			break
		case "capability.battery":
			break
		case "capability.beacon":
			break
		case "capability.carbonMonoxideDetector":
			break
		case "capability.colorControl":
			break
		case "capability.contactSensor":
			if (contactObjects == 0) {
				contactObject0 = metaData['name']
				this[contactObject0] = new ContactSensors({}, 1)
			} else if (contactObjects == 1) {
				contactObject1 = metaData['name']
				this[contactObject1] = new ContactSensors({}, 1)
			} else if (contactObjects == 2) {
				contactObject2 = metaData['name']
				this[contactObject2] = new ContactSensors({}, 1)
			}

			contactObjects=contactObjects+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class contactSensor!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.contactObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class contactSensor!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.contactObject\n")
			}
			break
		case "capability.doorControl":
			if (doorControlObjects == 0) {
				doorControlObject0 = metaData['name']
				this[doorControlObject0] = new DoorControls({}, 1)
			} else if (doorControlObjects == 1) {
				doorControlObject1 = metaData['name']
				this[doorControlObject1] = new DoorControls({}, 1)
			} else if (doorControlObjects == 2) {
				doorControlObject2 = metaData['name']
				this[doorControlObject2] = new DoorControls({}, 1)
			}

			doorControlObjects=doorControlObjects+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class door control!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.doorControlObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class door control!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.doorControlObject\n")
			}
			break
		case "capability.energyMeter":
			break
		case "capability.illuminanceMeasurement":
			break
		case "capability.accelerationSensor":
			break
		case "capability.motionSensor":
			break
		case "capability.musicPlayer":
			if (musicPlayerObjects == 0) {
				musicPlayerObject0 = metaData['name']
				this[musicPlayerObject0] = new MusicPlayers({}, 1)
			} else if (musicPlayerObjects == 1) {
				musicPlayerObject1 = metaData['name']
				this[musicPlayerObject1] = new MusicPlayers({}, 1)
			} else if (musicPlayerObjects == 2) {
				musicPlayerObject2 = metaData['name']
				this[musicPlayerObject2] = new MusicPlayers({}, 1)
			}

			musicPlayerObjects=musicPlayerObjects+1

			settings.put(metaData['name'], metaData['name']) 

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class music player!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.musicPlayerObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class music player!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.musicPlayerObject\n")
			}
			break
		case "capability.powerMeter":
			break
		case "capability.presenceSensor":
			if (presenceSensorObjects == 0) {
				presenceSensorObject0 = metaData['name']
				this[presenceSensorObject0] = new PresenceSensors({}, 1)
			} else if (presenceSensorObjects == 1) {
				presenceSensorObject1 = metaData['name']
				this[presenceSensorObject1] = new PresenceSensors({}, 1)
			} else if (presenceSensorObjects == 2) {
				presenceSensorObject2 = metaData['name']
				this[presenceSensorObject2] = new PresenceSensors({}, 1)
			}

			presenceSensorObjects=presenceSensorObjects+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class presence sensor!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.presenceSensorObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class presence sensor!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.presenceSensorObject\n")
			}
			break
		case "capability.relativeHumidityMeasurement":
			break
		case "capability.relaySwitch":
			break
		case "capability.sleepSensor":
			break
		case "capability.smokeDetector":
			break
		case "capability.stepSensor":
			break
		case "capability.switch":
			if (switchObjects == 0) {
				switchObject0 = metaData['name']
				this[switchObject0] = new Switches({}, 1)
			} else if (switchObjects == 1) {
				switchObject1 = metaData['name']
				this[switchObject1] = new Switches({}, 1)
			} else if (switchObjects == 2) {
				switchObject2 = metaData['name']
				this[switchObject2] = new Switches({}, 1)
			}

			switchObjects=switchObjects+1
			
			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class switch!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.switchObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class switch!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.switchObject\n")
			}
			break
		case "capability.switchLevel":
			break
		case "capability.temperatureMeasurement":
			break
		case "capability.thermostat":
			if (thermostatObjects == 0) {
				thermostatObject0 = metaData['name']
				this[thermostatObject0] = new Thermostats({}, 1)
			} else if (thermostatObjects == 1) {
				thermostatObject1 = metaData['name']
				this[thermostatObject1] = new Thermostats({}, 1)
			} else if (thermostatObjects == 2) {
				thermostatObject2 = metaData['name']
				this[thermostatObject2] = new Thermostats({}, 1)
			}

			thermostatObjects=thermostatObjects+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class thermostat!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.thermostatObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class thermostat!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.thermostatObject\n")
			}
			break
		case "capability.valve":
			break
		case "capability.waterSensor":
			break
		case "capability.touchSensor":
			if (touchSensorObjects == 0) {
				touchSensorObject0 = metaData['name']
				this[touchSensorObject0] = new NfcTouch({}, 1)
			} else if (touchSensorObjects == 1) {
				touchSensorObject1 = metaData['name']
				this[touchSensorObject1] = new NfcTouch({}, 1)
			} else if (touchSensorObjects == 2) {
				touchSensorObject2 = metaData['name']
				this[touchSensorObject2] = new NfcTouch({}, 1)
			}

			touchSensorObjects=touchSensorObjects+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class Touch Sensor!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.touchSensorObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class Touch Sensor!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.touchSensorObject\n")
			}
			break
		case "capability.imageCapture":
			break
		case "device.mobilePresence":
			break
		case "device.aeonKeyFob":
			if (aeonKeyFobObjects == 0) {
				aeonKeyFobObject0 = metaData['name']
				this[aeonKeyFobObject0] = new AeonKeyFobs({}, 1)
			} else if (aeonKeyFobObjects == 1) {
				aeonKeyFobObject1 = metaData['name']
				this[aeonKeyFobObject1] = new AeonKeyFobs({}, 1)
			} else if (aeonKeyFobObjects == 2) {
				aeonKeyFobObject2 = metaData['name']
				this[aeonKeyFobObject2] = new AeonKeyFobs({}, 1)
			}

			aeonKeyFobObjects=aeonKeyFobObjects+1

			settings.put(metaData['name'], metaData['name']) 

			if (App == "App1") {
				extractedObjectsApp1.append("//Object for class aeon key fob!\n")
				extractedObjectsApp1.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp1.append(metaData['name']+" = obj.aeonKeyFobObject\n")		
			} else {
				extractedObjectsApp2.append("//Object for class aeon key fob!\n")
				extractedObjectsApp2.append("def "+metaData['name']+"\n")
				extractedObjectsConstructorApp2.append(metaData['name']+" = obj.aeonKeyFobObject\n")
			}
			break
		case "mode":
			def userInput = System.console().readLine 'Enter the mode:'

			if (modeVariables == 0) {
				mode0 = metaData['name']
				this[mode0] = userInput
			} else if (modeVariables == 1) {
				mode1 = metaData['name']
				this[mode1] = userInput
			} else if (modeVariables == 2) {
				mode2 = metaData['name']
				this[mode2] = userInput
			} else if (modeVariables == 3) {
				mode3 = metaData['name']
				this[mode3] = userInput
			} else if (modeVariables == 4) {
				mode4 = metaData['name']
				this[mode4] = userInput
			} else if (modeVariables == 5) {
				mode5 = metaData['name']
				this[mode5] = userInput
			}

			modeVariables=modeVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for mode!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for mode!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			}
			break
		case "decimal":
			break
		case "text":
			break
		case "number":
			def userInput = System.console().readLine 'Enter the number:'
			
			if (numberVariables == 0) {
				number0 = metaData['name']
				this[number0] = userInput
			} else if (numberVariables == 1) {
				number1 = metaData['name']
				this[number1] = userInput
			} else if (numberVariables == 2) {
				number2 = metaData['name']
				this[number2] = userInput
			} else if (numberVariables == 3) {
				number3 = metaData['name']
				this[number3] = userInput
			} else if (numberVariables == 4) {
				number4 = metaData['name']
				this[number4] = userInput
			} else if (numberVariables == 5) {
				number5 = metaData['name']
				this[number5] = userInput
			}

			numberVariables=numberVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for number!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = "+userInput+"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for number!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = "+userInput+"\n")
			}
			break
		case "time":
			def userInput = System.console().readLine 'Enter the time:'
			
			if (timeVariables == 0) {
				time0 = metaData['name']
				this[time0] = userInput
			} else if (timeVariables == 1) {
				time1 = metaData['name']
				this[time1] = userInput
			} else if (timeVariables == 2) {
				time2 = metaData['name']
				this[time2] = userInput
			} else if (timeVariables == 3) {
				time3 = metaData['name']
				this[time3] = userInput
			} else if (timeVariables == 4) {
				time4 = metaData['name']
				this[time4] = userInput
			} else if (timeVariables == 5) {
				time5 = metaData['name']
				this[time5] = userInput
			}

			timeVariables=timeVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for time!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for time!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			}
			break
		case "enum":
			def userInput = System.console().readLine 'Enter the enum:'
	
			if (enumVariables == 0) {
				enum0 = metaData['name']
				this[enum0] = userInput
			} else if (enumVariables == 1) {
				enum1 = metaData['name']
				this[enum1] = userInput
			} else if (enumVariables == 2) {
				enum2 = metaData['name']
				this[enum2] = userInput
			} else if (enumVariables == 3) {
				enum3 = metaData['name']
				this[enum3] = userInput
			} else if (enumVariables == 4) {
				enum4 = metaData['name']
				this[enum4] = userInput
			} else if (enumVariables == 5) {
				enum5 = metaData['name']
				this[enum5] = userInput
			}

			enumVariables=enumVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for enum!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for enum!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			}
			break
		case "bool":
			break
		case "phone":
			def userInput = System.console().readLine 'Enter the phone:'

			if (phoneVariables == 0) {
				phone0 = metaData['name']
				this[phone0] = userInput
			} else if (phoneVariables == 1) {
				phone1 = metaData['name']
				this[phone1] = userInput
			} else if (phoneVariables == 2) {
				phone2 = metaData['name']
				this[phone2] = userInput
			} else if (phoneVariables == 3) {
				phone3 = metaData['name']
				this[phone3] = userInput
			} else if (phoneVariables == 4) {
				phone4 = metaData['name']
				this[phone4] = userInput
			} else if (phoneVariables == 5) {
				phone5 = metaData['name']
				this[phone5] = userInput
			}

			phoneVariables=phoneVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for phone!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = "+userInput+"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for phone!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = "+userInput+"\n")
			}
			break
		case "contact":
			def userInput = System.console().readLine 'Enter the metaData['name'] of the contact:'
	
			if (contactVariables == 0) {
				contact0 = metaData['name']
				this[contact0] = userInput
			} else if (contactVariables == 1) {
				contact1 = metaData['name']
				this[contact1] = userInput
			} else if (contactVariables == 2) {
				contact2 = metaData['name']
				this[contact2] = userInput
			} else if (contactVariables == 3) {
				contact3 = metaData['name']
				this[contact3] = userInput
			} else if (contactVariables == 4) {
				contact4 = metaData['name']
				this[contact4] = userInput
			} else if (contactVariables == 5) {
				contact5 = metaData['name']
				this[contact5] = userInput
			}

			contactVariables=contactVariables+1

			settings.put(metaData['name'], metaData['name'])

			if (App == "App1") {			
				extractedObjectsApp1.append("//Global variable for contact!\n")
				extractedObjectsApp1.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			} else {
				extractedObjectsApp2.append("//Global variable for contact!\n")
				extractedObjectsApp2.append("def "+metaData['name']+" = \""+userInput+"\"\n")
			}
			break
		default:
			break
	}
}

def label(LinkedHashMap metaData) {
	if (metaData.containsKey('title')) {
		println metaData['title']
	}
	if (metaData.containsKey('options')) {
		println "Options: "+metaData['options']
	}

	println("//IGNORE--ForMobileUse//")
}

def mode(LinkedHashMap metaData) {
	if (metaData.containsKey('title')) {
		println metaData['title']
	}
	if (metaData.containsKey('options')) {
		println "Options: "+metaData['options']
	}

	println("//IGNORE--ForMobileUse//")
}
/////Input Methods/////


/////MethodsForExtraction/////
def definition(LinkedHashMap metaData) {
	println("///Just some information///")
}

def preferences(Closure inputData) {
	find(inputData) //Run the closure to extract pages/sections/inputMethods
	if (App == "App1") {			
		extractedObjectsConstructorApp1.append("//Global variable for settings!\n")
		extractedObjectsConstructorApp1.append("settings = $settings\n")
	} else {
		extractedObjectsConstructorApp2.append("//Global variable for settings!\n")
		extractedObjectsConstructorApp2.append("settings = $settings\n")
	}
}

def page(LinkedHashMap metaData, Closure inputData) {
	if (metaData.containsKey('name'))
		println(metaData['name'])
	if (metaData.containsKey('title'))
		println(metaData['title'])

	find(inputData) //Run the closure to extract sections/inputMethods
}

def page(LinkedHashMap metaData) {
	def nameOfFunction = metaData['name']
	"$nameOfFunction"() //Call the page	
}

def dynamicPage(LinkedHashMap metaData, Closure inputData) {
	if (metaData.containsKey('name'))
		println(metaData['name'])
	if (metaData.containsKey('title'))
		println(metaData['title'])

	find(inputData) //Run the closure to extract sections/inputMethods
}

def section(String title, Closure inputData) {
	println(title)
	find(inputData) //Run the closure to extract inputMethods
}

def section(Closure inputData) {
	find(inputData) //Run the closure to extract inputMethods
}

def section(LinkedHashMap metaData, Closure inputData) {
	find(inputData) //Run the closure to extract inputMethods
}
/////MethodsForExtraction/////

