//Create a class for lock device
package Lock
import Timer.SimulatedTimer

public class Lock {
	private String id
	private String label
	private String displayName
	private String lockState
	private String currentLock
	private String lockLatestValue
	def sendEvent	
	def timers


	Lock(Closure sendEvent, String id, String label, String displayName, String lockState, String lockLatestValue) {
		this.id = id
		this.label = label
		this.sendEvent = sendEvent
		this.displayName = displayName
		this.lockState = lockState
		this.currentLock = lockState
		this.lockLatestValue = lockLatestValue
		this.timers = new SimulatedTimer()
	}

	//By Apps
	def lock() {
		println("the door with id:$id is locked!")
		this.lockLatestValue = this.lockState
		this.lockState = "locked"
		this.currentLock = "locked"
		sendEvent([name: "lock", value: "locked", deviceId: this.id, descriptionText: "",
			  displayed: true, linkText: "", isStateChange: false, unit: "", data: [value: "locked"]])
	}

	def lock(LinkedHashMap metaData) {
		def task = timers.runAfter(metaData["delay"]) {
			println("the door with id:$id is locked!")
			this.lockLatestValue = this.lockState
			this.lockState = "locked"
			this.currentLock = "locked"
			sendEvent([name: "lock", value: "locked", deviceId: this.id, descriptionText: "",
				  displayed: true, linkText: "", isStateChange: false, unit: "", data: [value: "locked"]])
		}
	}
	
	def unlock() {
		println("the door with id:$id is unlocked!")
		this.lockLatestValue = this.lockState
		this.lockState = "unlocked"
		this.currentLock = "unlocked"
		sendEvent([name: "unlock", value: "unlocked", deviceId: this.id, descriptionText: "",
		          displayed: true, linkText: "", isStateChange: false, unit: "", data: [value: "unlocked"]])
	}

	def unlock(LinkedHashMap metaData) {
		def task = timers.runAfter(metaData["delay"]) {
			println("the door with id:$id is locked!")
			this.lockLatestValue = this.lockState
			this.lockState = "locked"
			this.currentLock = "locked"
			sendEvent([name: "unlock", value: "unlocked", deviceId: this.id, descriptionText: "",
				  displayed: true, linkText: "", isStateChange: false, unit: "", data: [value: "unlocked"]])
		}
	}

	//By Model Checker
	def setValue(String value) {
		println("the door with id:$id is $value!")
		this.lockLatestValue = this.lockState
		this.lockState = value
		this.currentLock = value
	}
	
	def currentValue(String deviceFeature) {
		if (deviceFeature == "lock") {
			return lockState
		}
	}

	def latestValue(String deviceFeature) {
		if (deviceFeature == "lock") {
			return lockLatestValue
		}
	}
}
